﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net.Sockets;
using System.Net;

namespace location
{
    public class ArgBreaker
    {
        string HTTP9 = "-h9";
        string HTTP11 = "-h1";
        string HTTP10 = "-h0";
        string WHOIS = "Whois";
        string name = null;
        string location = null;
        string protocol = null;
        string ipAddressString = "whois.net.dcs.hull.ac.uk";
        int portNo = 43;

        public ArgBreaker(string[] args)
        {
            FindUserInfo(args);
            protocol = FindProtocol(args);
        }

        /// <summary>
        /// Finds the user info.
        /// </summary>
        /// <param name="args">Arguments to he client</param>
        private void FindUserInfo(string[] args)
        {
            string[] useInfo = new string[2];
            
            for (int i = 0; i < args.Length; i++)
            {
                if (args[i] == "-h")
                {
                    if (args[i + 1] == "localhost")
                    {
                        ipAddressString = "127.0.0.1";
                        continue;
                    }
                    else
                    {
                        ipAddressString = args[i + 1];
                        continue;
                    }
                }
                else if (args[i] == "-p")
                {
                    try
                    {
                        portNo = int.Parse(args[i + 1]);
                        continue;
                    }
                    catch
                    {
                        Console.WriteLine("ERROR: Incorrect Port Number");
                    }
                }
                else if (args[i] == HTTP9)
                    continue;
                else if (args[i] == HTTP11)
                    continue;
                else if (args[i] == HTTP10)
                    continue;
                else if (useInfo.Length == 0)
                    useInfo[0] = args[i];
                else
                    useInfo[1] = args[i];
            }
            name = useInfo[0];
            location = useInfo[1];
        }

        /// <summary>
        /// This accepts the arguments and runs through them trying to understand which protocol they belong to.
        /// </summary>
        /// <param name="args">Arguments to client</param>
        /// <returns>Returns what protocol it is</returns>
        private string FindProtocol(string[] args)
        {
            for (int i = 0; i < args.Length; i++)
            {
                if (args[i].Contains(HTTP9) && args[i] == HTTP9)
                    return HTTP9;
                else if (args[i].Contains(HTTP11) && args[i] == HTTP11)
                    return HTTP11;
                else if (args[i].Contains(HTTP10) && args[i] == HTTP10)
                    return HTTP10;
            }
            return WHOIS;
        }

        /// <summary>
        /// Gets the name.
        /// </summary>
        /// <returns>Returns name</returns>
        public string nameGET()
        {
            return name;
        }

        /// <summary>
        /// Gets the location.
        /// </summary>
        /// <returns>Returns location</returns>
        public string locationGET()
        {
            return location;
        }

        /// <summary>
        /// Gets the protocol.
        /// </summary>
        /// <returns>Returns protocol</returns>
        public string protocolGET()
        {
            return protocol;
        }

        public string ipAddressStringGET()
        {
            return ipAddressString;
        }

        public int portNoGET()
        {
            return portNo;
        }
    }
}
