﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net.Sockets;
using System.Net;

namespace location
{
    public class HTTP10Read
    {
        StreamReader sr;
        public HTTP10Read(TcpClient client, string[] args, string name, string location)
        {
            sr = new StreamReader(client.GetStream());
            ReadMessageFromServer(args, name, location);
        }

        private void ReadMessageFromServer(string[] args, string name, string location)
        {
            string ServerMessage = sr.ReadToEnd();
            if (ServerMessage.Contains("404"))
            {
                Console.WriteLine(ServerMessage); //Replies with server error
            }
            else if (ServerMessage.Contains("200"))
            {
                Console.WriteLine("{0} location changed to be {1}", name, location); //Says the location has changed. E.g. "cssbct location changed to be LLT"
            }
            else
            {
                ServerMessage.Remove(0, 53);
                Console.WriteLine("{0} is in {1}", name, ServerMessage); //Replies with the user and their location
            }
        }
    }
}
