﻿using System;
using System.IO;
using System.Net.Sockets;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Diagnostics;
using System.Net;

namespace locationserver
{
    class Program
    {
        static Dictionary<string, string> LocationDict = new Dictionary<string, string>();

        public static void runServer()
        {
            TcpListener listener;
            
            listener = new TcpListener(IPAddress.Any, 43);
            listener.Start();

            while (true)
            {
                Socket connection = listener.AcceptSocket();
                NetworkStream socketStream = new NetworkStream(connection);
                socketStream.ReadTimeout = 1000;
                try
                {
                    doRequest(socketStream);
                }
                catch (Exception e)
                {
                    Debug.Print(e.ToString());
                }
                finally
                {
                    socketStream.Close();
                    connection.Close();
                }
            }
        }

        public static void doRequest(NetworkStream connection)
        {
            StreamWriter sw = new StreamWriter(connection);
            StreamReader sr = new StreamReader(connection);

            string inputStreamString = sr.ReadLine();           //Input String
            string outputStreamString = null;                   //Output String
            string inputStreamWhole = sr.ReadToEnd();           //Read the whole message
            char[] deliminators = new char[1];
            deliminators[0] = ' ';
            string[] splitString = inputStreamString.Split(deliminators); //This takes in arguments by splitting them using a defined character. In this case a space between arguments.

            if (splitString.Length == 1)    
            {
                Console.WriteLine(inputStreamString);
                LocationDict.TryGetValue(inputStreamString, out outputStreamString);    //Displays where cssbct is.
                sw.WriteLine(outputStreamString);
                sw.Flush();
            }
            else if (splitString.Length == 2)
            {
                LocationDict.TryGetValue(splitString[0], out outputStreamString);
                LocationDict[splitString[0]] = splitString[1];                         //Changes it and then tells the client OK.
                sw.WriteLine("OK");
                sw.Flush();
            }
            else if (splitString.Length > 2)
            {
                ProtocolChoice.ProtocolChoice(inputStreamWhole, outputStreamString, sw, sr, LocationDict);
            }

        }

        static void Main(string[] args)
        {         
            LocationDict.Add("cssbct", "LLT");
            runServer();
        }
    }
}
