﻿using System;
using System.IO;
using System.Net.Sockets;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Diagnostics;
using System.Net;

namespace locationserver
{
    class ProtocolChoice
    {
        public void ProtocolChoice(string inputStream, string outputStream, StreamWriter sw, StreamReader sr, Dictionary<string, string> LocationDict)
        {
            char[] deliminators = new char[1];
            deliminators[0] = ' ';
            deliminators[1] = '\n';
            //deliminators[2] = '\r';// To get a drop line (New Paragraph) use \r\n
            string[] splitString = inputStream.Split(deliminators);

            #region if Statement for Protocol
            if (inputStream.Contains("GET"))
            {
                HTTPNineGET(inputStream, splitString, outputStream, sw, sr, LocationDict);
            }
            if (inputStream.Contains("GET") && inputStream.Contains("HTTP/1.0"))
            {
                HTTPTenGET(inputStream, splitString, outputStream, sw, sr, LocationDict);
            }
            if (inputStream.Contains("GET") && inputStream.Contains("HTTP/1.1"))
            {
                HTTPOneOneGET(inputStream, splitString, outputStream, sw, sr, LocationDict);
            }
            if (inputStream.Contains("PUT"))
            {
                HTTPNinePOST(inputStream, splitString, outputStream, sw, sr, LocationDict);
            }
            if (inputStream.Contains("POST") && inputStream.Contains("HTTP/1.0"))
            {
                HTTPTenPOST(inputStream, splitString, outputStream, sw, sr, LocationDict);
            }
            if (inputStream.Contains("POST") && inputStream.Contains("HTTP/1.1"))
            {
                HTTPOneOnePOST(inputStream, splitString, outputStream, sw, sr, LocationDict);
            }
            #endregion
        }

        #region All Of The GET/POST Methods

        static void HTTPNineGET(string inputStream, string[] spiltString, string outputStream, StreamWriter sw, StreamReader sr, Dictionary<string, string> LocationDict)
        {
            //HTTP 0.9 Request - GETTING LOCATION
            Console.WriteLine(inputStream);
            try
            {
                if (spiltString[1].Contains("/"))
                {
                    spiltString[1].Remove(0);
                }

                LocationDict.TryGetValue(spiltString[1], out outputStream);
                HTTPNineResp.GETRequest(outputStream,sw);
            }
            catch
            {
                HTTPNineResp.FAILRequest(sw);
            }
        }

        static void HTTPTenGET(string inputStream, string[] spiltString, string outputStream, StreamWriter sw, StreamReader sr, Dictionary<string, string> LocationDict)
        {
            //HTTP 1.0 Request - GETTING LOCATION
            try
            {
                Console.WriteLine(inputStream);

                if (spiltString[1].Contains("/"))
                {
                    spiltString[1].Remove(0);
                }

                LocationDict.TryGetValue(spiltString[1], out outputStream);
                HTTPTen.GETRequest(outputStream, sw);
            }
            catch
            {
                HTTPTen.FAILRequest(sw);
            }
        }

        static void HTTPOneOneGET(string inputStream, string[] spiltString, string outputStream, StreamWriter sw, StreamReader sr, Dictionary<string, string> LocationDict)
        {
            //HTTP 1.1 Request - GETTING LOCATION
            try
            {
                Console.WriteLine(inputStream);

                if (spiltString[1].Contains("/"))
                {
                    spiltString[1].Remove(0);
                }

                LocationDict.TryGetValue(spiltString[1], out outputStream);
                HTTPOneOneResp.GETRequest(outputStream, sw);
            }
            catch
            {
                HTTPOneOneResp.FAILRequest(sw);
            }
        }
        static void HTTPNinePOST(string inputStream, string[] spiltString, string outputStream, StreamWriter sw, StreamReader sr, Dictionary<string, string> LocationDict)
        {
            //HTTP 0.9 Request - POSTING LOCATION
            try
            {
                if (spiltString[1].Contains("/"))
                {
                    spiltString[1].Remove(0);
                }

                LocationDict[spiltString[1]] = spiltString[2];
                HTTPNineResp.POSTRequest(sw);
            }
            catch
            {
                HTTPNineResp.FAILRequest(sw);
            }
        }

        static void HTTPTenPOST(string inputStream, string[] spiltString, string outputStream, StreamWriter sw, StreamReader sr, Dictionary<string, string> LocationDict)
        {
            //HTTP 1.0 Request - POSTING LOCATION
            try
            {
                if (spiltString[1].Contains("/"))
                {
                    spiltString[1].Remove(0);
                }

                LocationDict[spiltString[1]] = spiltString[5];
                HTTPTen.POSTRequest(sw);
            }
            catch
            {
                HTTPTen.FAILRequest(sw);
            }
        }

        static void HTTPOneOnePOST(string inputStream, string[] spiltString, string outputStream, StreamWriter sw, StreamReader sr, Dictionary<string, string> LocationDict)
        {
            //HTTP 1.1 Request - POSTING LOCATION
            try
            {
                if (spiltString[1].Contains("/"))
                {
                    spiltString[1].Remove(0);
                }

                LocationDict[spiltString[1]] = spiltString[8];
                HTTPOneOneResp.POSTRequest(sw);
            }
            catch
            {
                HTTPOneOneResp.FAILRequest(sw);
            }
        }
        #endregion
    }
}
